diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index bde66452d..62b5b9bcf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -25,6 +25,7 @@ import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.particle.ParticleEmitterRange;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -191,10 +192,39 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) { }
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        if (world.isClientSide) {
+            ParticleEmitterRange t = this.getParticleEmitterRange();
+            if (t != null) {
+                world.particleEmitters.add(tilePos, t);
+            }
+        }
+    }
+
+    @Override
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
+        if (world.isClientSide) {
+            ParticleEmitterRange t = this.getParticleEmitterRange();
+            if (t != null) {
+                world.particleEmitters.remove(tilePos);
+            }
+        }
+    }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) { }
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+        this.onPlacedOnSide(world, tilePos, side, xHit, yHit);
+
+        if (world.isClientSide) {
+            ParticleEmitterRange t = this.getParticleEmitterRange();
+            if (t != null) {
+                world.particleEmitters.add(tilePos, t);
+            }
+        }
+    }
+
+    @Override
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) { }
 
     @Override
     public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) { }
@@ -438,14 +468,6 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
         return true;
     }
 
-    @Override
-    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
-        this.onPlacedOnSide(world, tilePos, side, xHit, yHit);
-    }
-
-    @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) { }
-
     @Override
     public @NotNull String getLanguageKey(final int data) {
         return this.block.getKey();
@@ -493,4 +515,8 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     public @NotNull ItemStack getDefaultStack() {
         return this.block.getDefaultStack();
     }
+
+    public @Nullable ParticleEmitterRange getParticleEmitterRange() {
+        return null; // null by default, 16 block radius
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java
index 8db54e008..054fea3df 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java
@@ -17,9 +17,6 @@ public class BlockLogicAsh
 
     @Override
     public ItemStack[] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
-        return switch (dropCause) {
-            case PICK_BLOCK, SILK_TOUCH -> new ItemStack[] { new ItemStack(this) };
-            default -> null;
-        };
+        return new ItemStack[] { new ItemStack(this) };
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonepile.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonePile.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLogicBonepile.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicBonePile.java
index 00bc1c4fc..84c3ebcb3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonepile.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBonePile.java
@@ -10,10 +10,10 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicBonepile
+public class BlockLogicBonePile
     extends BlockLogicFlower {
 
-    public BlockLogicBonepile(final @NotNull Block<?> block) {
+    public BlockLogicBonePile(final @NotNull Block<?> block) {
         super(block);
         final float f = 0.4F;
         this.setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
@@ -31,13 +31,14 @@ public class BlockLogicBonepile
 
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int meta, final @Nullable TileEntity tileEntity) {
-        final int quantity = world.rand.nextInt(3) + 1;
-
         return switch (dropCause) {
             case SILK_TOUCH, PICK_BLOCK -> new ItemStack[] { new ItemStack(this) };
             default -> {
-                if (quantity == 0 || world.rand.nextInt(8) != 0) yield null;
-                yield new ItemStack[] { new ItemStack(Items.BONE, quantity) };
+                int dropChance = 5;
+                if (world.rand.nextInt(dropChance) == 0) {
+                    yield new ItemStack[] { new ItemStack(Items.BONE, 1) };
+                }
+                yield null;
             }
         };
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderMagmatic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderMagmatic.java
new file mode 100644
index 000000000..4c551034a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderMagmatic.java
@@ -0,0 +1,43 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicBoulderMagmatic extends BlockLogicFlower {
+	public BlockLogicBoulderMagmatic(@NotNull Block<?> block) {
+		super(block);
+		this.setBlockBounds(0.1F, 0.0F, 0.1F, 0.9F, 0.8F, 0.9F);
+	}
+
+	@Override
+	public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+		entity.maxFireTicks = 100;
+		entity.remainingFireTicks = 100;
+		entity.activeFireBlock = Blocks.FIRE;
+	}
+
+	@Override
+	public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
+		return this.mayPlaceOn(world.getBlockType(tilePos.down(new TilePos())));
+	}
+
+	@Override
+	public boolean mayPlaceOn(@NotNull Block<?> block) {
+		return block.isSolidRender();
+	}
+
+	@Override
+	public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int meta, @Nullable TileEntity tileEntity) {
+		return switch (dropCause) {
+			case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
+			default -> null;
+		};
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderSulfuric.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderSulfuric.java
new file mode 100644
index 000000000..5fcbe3029
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoulderSulfuric.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+public class BlockLogicBoulderSulfuric extends BlockLogicBoulderMagmatic {
+	public BlockLogicBoulderSulfuric(@NotNull Block<?> block) {
+		super(block);
+		this.setBlockBounds(0.1F, 0.0F, 0.1F, 0.9F, 0.8F, 0.9F);
+	}
+
+	@Override
+	public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+		entity.maxFireTicks = 100;
+		entity.remainingFireTicks = 100;
+		entity.activeFireBlock = Blocks.FIRE_SULFURIC;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrimstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrimstone.java
new file mode 100644
index 000000000..d44d73ab5
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrimstone.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicBrimstone extends BlockLogic {
+	public BlockLogicBrimstone(@NotNull Block<?> block, @NotNull Material material) {
+		super(block, material);
+	}
+
+	@Override
+	public ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+		return dropCause == EnumDropCause.PISTON_CRUSH ? new ItemStack[]{new ItemStack(Blocks.BRIMSAND, world.rand.nextInt(2) + 1)} : super.getBreakResult(world, dropCause, data, tileEntity);
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrimthaw.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrimthaw.java
new file mode 100644
index 000000000..a8884933e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrimthaw.java
@@ -0,0 +1,50 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class BlockLogicBrimthaw extends BlockLogicMagma {
+
+    public BlockLogicBrimthaw(@NotNull Block<?> block) {
+        super(block);
+    }
+
+    @Override
+    public boolean canMelt(@NotNull World world, @NotNull TilePosc tilePos) {
+        boolean canMelt = false;
+        final TilePos queryPos = new TilePos();
+        for (final Direction dir : Direction.all) {
+            final Block<?> block = world.getBlockType(tilePos.add(dir, queryPos));
+            final Material adjacentMaterial = block.getMaterial();
+            if (adjacentMaterial == Materials.WATER) {
+                return false;
+            }
+            canMelt |= adjacentMaterial == Materials.ACID;
+        }
+        return canMelt;
+    }
+
+    @Override
+    public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+        if (entity instanceof EntityItem) return; // Don't burn items for this block
+        entity.fireHurt(Blocks.FIRE_SULFURIC);
+    }
+
+    @Override
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (canMelt(world, tilePos)) {
+            world.setBlockTypeNotify(tilePos, Blocks.FLUID_ACID_FLOWING);
+        }
+    }
+
+}
+
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java
new file mode 100644
index 000000000..31c37986c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java
@@ -0,0 +1,74 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.animal.MobWolf;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class BlockLogicEmber extends BlockLogic {
+	public BlockLogicEmber(@NotNull Block<?> block, @NotNull Material material) {
+		super(block, material);
+	}
+
+	@Override
+	public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+		if(entity instanceof Player || entity instanceof MobWolf){
+			this.ignite(world, tilePos, entity);
+		}
+	}
+
+	@Override
+	public void onEntityWalkedOn(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+		if(entity instanceof Player || entity instanceof MobWolf){ // We do a little trolling here...
+			this.ignite(world, tilePos, entity);
+		}
+	}
+
+	public void ignite(@NotNull World world, @NotNull TilePosc tilePos, Entity entity) {
+		if (entity != null) {
+			entity.hurt(null, 8, DamageType.BLAST);
+			entity.remainingFireTicks = 100;
+			entity.fling(1.0f, 1.0f, 1.0f, 0.0f);
+		}
+
+		world.setBlockType(tilePos, Blocks.AIR);
+		world.createExplosion(null, tilePos.x(), tilePos.y(), tilePos.z(), 3.0F, true, false);
+	}
+
+	@Override
+	public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+		double xPos = (double) tilePos.x() + rand.nextDouble();
+		double zPos = (double) tilePos.z() + rand.nextDouble();
+
+		TilePos blockAboveTilePos = new TilePos(tilePos.x(), tilePos.y() + 1, tilePos.z());
+
+		Block<?> block = world.getBlockType(blockAboveTilePos);
+		double yPos = tilePos.y() + 1.1D;
+
+		boolean isAir = block == Blocks.AIR;
+		boolean isAshLayer = block == Blocks.LAYER_ASH;
+
+		if (isAshLayer) {
+			int data = world.getBlockData(blockAboveTilePos) & BlockLogicLayerBase.MASK_HEIGHT;
+			int layers = data + 1;
+			yPos += layers * 0.125D;
+		}
+
+		if (isAir || isAshLayer) {
+			if (rand.nextInt(3) == 0) {
+				world.spawnParticle("flame", xPos, yPos, zPos, 0.0F, 0.01F, 0.0F, 0, false);
+				world.spawnParticle("largesmoke", xPos, yPos + 0.30, zPos, 0.0F, 0.02F, 0.0F, 0, false);
+				world.spawnParticle("largesmoke", xPos, yPos + 0.30, zPos, 0.0F, 0.01F, 0.0F, 0, false);
+			}
+			world.spawnParticle("largesmoke", xPos, yPos + 0.30, zPos, 0.0F, 0.015F, 0.0F, 0, false);
+		}
+	}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 593ab4942..9372320e5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -6,6 +6,10 @@ import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.tag.Tag;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.item.block.ItemBlock;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.enums.EnumDropCause;
@@ -122,7 +126,15 @@ public class BlockLogicFire
     }
 
     public void setBurnResult(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        world.setBlockTypeNotify(tilePos, this.getBurnResult(world, tilePos));
+        final Block<?> currentBlock = world.getBlockType(tilePos);
+        final int currentData = world.getBlockData(tilePos);
+        final Block<?> resultBlock = this.getBurnResult(world, tilePos);
+
+        if (resultBlock != Blocks.AIR && resultBlock != this.block) {
+            world.setBlockTypeDataNotify(tilePos, resultBlock, currentData);
+        } else {
+            world.setBlockTypeNotify(tilePos, resultBlock);
+        }
     }
 
     @Override
@@ -130,7 +142,7 @@ public class BlockLogicFire
         TilePos queryPos = new TilePos();
 
         final @Nullable Block<?> blockUnder = world.getBlockType(tilePos.down(queryPos));
-        final boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN);
+        final boolean infiniBurn = blockUnder.hasTag(this.getInfiniteBurnTag());
 
         // Extinguish fire
         if (!this.isValidFireLocation(world, tilePos)) {
@@ -203,8 +215,7 @@ public class BlockLogicFire
 
                     if (world.getGameRuleValue(GameRules.DO_FIRE_SPREAD) && this.getBurnResult(world, localPos) == Blocks.AIR /* Fix for fire destroying moss blocks */) {
                         //Spread Fire with higher meta
-                        world.setBlockTypeDataNotify(localPos, this.block, Math.min(meta + rand.nextInt(5) / 4, 15));
-                    }
+                        world.setBlockTypeDataNotify(localPos, this.getSpreadFireBlock(), Math.min(meta + rand.nextInt(5) / 4, 15));}
                 }
             }
         }
@@ -218,8 +229,7 @@ public class BlockLogicFire
             if (random.nextInt(meta + 10) < 5 && !world.isBlockBeingRainedOn(tilePos)) {
                 if (this.getBurnResult(world, tilePos) == Blocks.AIR /* Fix for fire destroying moss blocks */) {
                     //Spread Fire with higher meta
-                    world.setBlockTypeDataNotify(tilePos, this.block, Math.min(meta + random.nextInt(5) / 4, 15));
-                }
+                    world.setBlockTypeDataNotify(tilePos, this.getSpreadFireBlock(), Math.min(meta + random.nextInt(5) / 4, 15));}
             } else {
                 this.setBurnResult(world, tilePos);
             }
@@ -281,12 +291,15 @@ public class BlockLogicFire
     @Override
     public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!world.isBlockNormalCube(tilePos.down(new TilePos())) && !this.canNeighborCatchFire(world, tilePos)) {
-
-            world.setBlockTypeNotify(tilePos, this.getBurnResult(world, tilePos));
+            this.setBurnResult(world, tilePos);
         }
     }
 
     protected @NotNull Block<?> getBurnResult(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        Block<?> blockAtPos = world.getBlockType(tilePos);
+        int blockDataAtPos = world.getBlockData(tilePos);
+        if (blockAtPos.getLogic() instanceof BlockLogicLog) return Blocks.LOG_SCORCHED;
+
         final @NotNull Block<?> block = world.getBlockType(tilePos);
         final @Nullable Block<?> noMossBlock = BlockLogicMoss.getNoMossBlock(block);
         return Objects.requireNonNullElse(noMossBlock, Blocks.AIR);
@@ -299,7 +312,7 @@ public class BlockLogicFire
             return;
         }
         if (!world.isBlockNormalCube(tilePos.down(queryPos)) && !this.canNeighborCatchFire(world, tilePos)) {
-            world.setBlockTypeNotify(tilePos, this.getBurnResult(world, tilePos));
+            this.setBurnResult(world, tilePos);
         } else {
             world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
         }
@@ -364,4 +377,17 @@ public class BlockLogicFire
             }
         }
     }
+
+    protected Tag<Block<?>> getInfiniteBurnTag() {
+        return BlockTags.INFINITE_BURN;
+    }
+
+    protected Block<?> getSpreadFireBlock() {
+        return this.block;
+    }
+
+    @Override
+    public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
+        entity.activeFireBlock = this.block;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
index 3b48a1e51..6a8b7b25c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
@@ -1,59 +1,22 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
-import net.minecraft.core.world.pos.TilePosc;
-import net.minecraft.core.world.weather.IPrecipitation;
+import net.minecraft.core.data.tag.Tag;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
-import java.util.Random;
+public class BlockLogicFireCold extends BlockLogicFire {
 
-public class BlockLogicFireCold
-    extends BlockLogicFire {
     public BlockLogicFireCold(final @NotNull Block<?> block) {
         super(block);
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
-        TilePos queryPos = new TilePos();
-        final @Nullable Block<?> blockUnder = world.getBlockType(tilePos.down(queryPos));
-        final boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN_COLD);
-
-        // Extinguish fire
-        if (!this.isValidFireLocation(world, tilePos)) {
-            this.setBurnResult(world, tilePos);
-        }
-
-        // Extinguish fire (Rain / Snow)
-        if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather() instanceof IPrecipitation && (
-            world.isBlockBeingRainedOn(tilePos)
-                || world.isBlockBeingRainedOn(tilePos.west(queryPos))
-                || world.isBlockBeingRainedOn(tilePos.east(queryPos))
-                || world.isBlockBeingRainedOn(tilePos.north(queryPos))
-                || world.isBlockBeingRainedOn(tilePos.south(queryPos)))) {
-            this.setBurnResult(world, tilePos);
-            return;
-        }
-
-        final int meta = world.getBlockData(tilePos);
-        if (meta < 15) {
-            world.setBlockData(tilePos, meta + rand.nextInt(3) / 2);
-        }
-        world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
-
-
-        if (!infiniBurn && !this.canNeighborCatchFire(world, tilePos)) {
-            if (!world.isBlockNormalCube(tilePos.down(queryPos)) || meta > 3) {
-                this.setBurnResult(world, tilePos);
-            }
-            return;
-        }
+    protected Tag<Block<?>> getInfiniteBurnTag() {
+        return BlockTags.INFINITE_BURN_COLD;
+    }
 
-        if (!infiniBurn && !canBurn(world, tilePos.down(queryPos)) && meta == 15 && rand.nextInt(4) == 0) {
-            this.setBurnResult(world, tilePos);
-        }
+    @Override
+    protected Block<?> getSpreadFireBlock() {
+        return Blocks.FIRE;
     }
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireSulfuric.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireSulfuric.java
new file mode 100644
index 000000000..3e8eeb4c3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireSulfuric.java
@@ -0,0 +1,25 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.data.tag.Tag;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+public class BlockLogicFireSulfuric extends BlockLogicFire {
+
+    public BlockLogicFireSulfuric(final @NotNull Block<?> block) {
+        super(block);
+    }
+
+    @Override
+    protected Tag<Block<?>> getInfiniteBurnTag() {
+        return BlockTags.INFINITE_BURN_SULFURIC;
+    }
+
+    @Override
+    protected Block<?> getSpreadFireBlock() {
+        return Blocks.FIRE_SULFURIC;
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 89f9f5c6c..01e71607e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -263,4 +263,19 @@ public abstract class BlockLogicFluid extends BlockLogic {
     public boolean isFullBlock(@NotNull World world, TilePos tilePos){
         return getFluidHeight(world, tilePos) == 1;
     }
+
+    public static boolean isAcid(@NotNull World world, TilePos pos) {
+        Block<?> block = world.getBlockType(pos);
+        return block == Blocks.FLUID_ACID_STILL || block == Blocks.FLUID_ACID_FLOWING;
+    }
+
+    public static boolean isWater(@NotNull World world, TilePos pos) {
+        Block<?> block = world.getBlockType(pos);
+        return block == Blocks.FLUID_WATER_STILL || block == Blocks.FLUID_WATER_FLOWING;
+    }
+
+    public static boolean isLava(@NotNull World world, TilePos pos) {
+        Block<?> block = world.getBlockType(pos);
+        return block == Blocks.FLUID_LAVA_STILL || block == Blocks.FLUID_LAVA_FLOWING;
+    }
 }
